<?php
/**
 * @file
 * @package sd
 * @version $Id$
**/

if(!defined('XOOPS_ROOT_PATH'))
{
    exit;
}

require_once SD_TRUST_PATH . '/class/AbstractListAction.class.php';

/**
 * Sd_ItemListAction
**/
class Sd_ItemListAction extends Sd_AbstractListAction
{
    /**
     * @brief   Sd_UpdateHanlder
    **/
    protected $_mUpdateHandler = null;
    
    /**
     * &_getHandler
     * 
     * @param   void
     * 
     * @return  Sd_ItemHandler
     * 
     * @protected
    **/
    function &_getHandler()
    {
        $handler =& $this->mAsset->getObject('handler', 'item');
        return $handler;
    }

    /**
     * &_getFilterForm
     * 
     * @param   void
     * 
     * @return  Sd_ItemFilterForm
     * 
     * @protected
    **/
    function &_getFilterForm()
    {
        // $filter =& new Sd_ItemFilterForm();
        $filter =& $this->mAsset->getObject('filter', 'item',false);
        $filter->prepare($this->_getPageNavi(), $this->_getHandler());
        return $filter;
    }

    /**
     * _getBaseUrl
     * 
     * @param   void
     * 
     * @return  string
     * 
     * @protected
    **/
    function _getBaseUrl()
    {
        return './index.php?action=ItemList';
    }

    /**
     * getDefaultView
     * 
     * @param   void
     * 
     * @return  Enum
    **/
    public function getDefaultView()
    {
        $this->_mUpdateHandler =& $this->mAsset->getObject('handler','update');
        if(!isset($_GET['regist_time']))
        {
            $cri = new Criteria(1,1);
            $cri->addSort('update_time','desc');
            $obj =& $this->_mUpdateHandler->getObjects($cri,1);
            if(count($obj) == 1)
            {
                $_GET['regist_time'] = $obj[0]->get('update_time');
            }
        }
        
        $this->mFilter =& $this->_getFilterForm();
        $this->mFilter->fetch();
        
        $handler =& $this->_getHandler();
        $this->mObjects =& $handler->getItemList($this->mFilter->getCriteria());
        
        return SD_FRAME_VIEW_INDEX;
    }

    /**
     * executeViewIndex
     * 
     * @param   XCube_RenderTarget  &$render
     * 
     * @return  void
     * 
     * @public
    **/
    function executeViewIndex(&$render)
    {
        $render->setTemplateName($this->mAsset->mDirname . '_item_list.html');
        #cubson::lazy_load_array('item', $this->mObjects);
        $render->setAttribute('objects', $this->mObjects);
        $render->setAttribute('pageNavi', $this->mFilter->mNavi);
        
        $render->setAttribute('enumHandler',$this->mAsset->getObject('handler','enum'));
        $render->setAttribute('updateHandler',$this->_mUpdateHandler);
    }
}

?>
