<?php
/**
 * @file
 * @package 
 * @version $Id$
**/

if(!defined('XOOPS_ROOT_PATH'))
{
    exit();
}

/**
 * @class   Sd_JumpAction
**/
class Sd_JumpAction extends Sd_AbstractAction
{
    /**
     * @brief   string
    **/
    const SD_URL = 'http://ragnarek.sakura.ne.jp/sd/';
    
    /**
     * @brief   string
    **/
    const SD_MODE_CHAR = 'char';
    
    /**
     * @brief   string
    **/
    const SD_MODE_PARTY = 'party';
    
    /**
     * @brief   string
    **/
    protected $_mId = null;
    
    /**
     * @brief   string
    **/
    protected $_mUrl = null;
    
    /**
     * @brief   string[]
    **/
    protected $_mMode = array(
        Sd_JumpAction::SD_MODE_CHAR,
        Sd_JumpAction::SD_MODE_PARTY
    );
    
    /**
     * @brief   string{}
    **/
    protected $_mBaseUrl = array();
    
    /**
     * prepare
     * 
     * @param   void
     * 
     * @return  bool
    **/
    public function prepare()
    {
        if(!parent::prepare())
        {
            return false;
        }
        
        $this->_mBaseUrl[Sd_JumpAction::SD_MODE_CHAR] = Sd_JumpAction::SD_URL . 'rep/result/Chardata%d.htm';
        $this->_mBaseUrl[Sd_JumpAction::SD_MODE_PARTY] = Sd_JumpAction::SD_URL . 'rep/result/Result%d.htm';
        
        return true;
    }
    
    /**
     * getDefaultView
     * 
     * @param   void
     * 
     * @return  Enum
    **/
    public function getDefaultView()
    {
        $handler =& $this->mAsset->getObject('handler', 'eno_pno_link');
        $link = $handler->get(intval($this->mRoot->mContext->mRequest->getRequest('eno')));
        
        if($link instanceof $handler->mClass)
        {
            switch($this->mRoot->mContext->mRequest->getRequest('mode'))
            {
                case Sd_JumpAction::SD_MODE_CHAR:
                    $this->_mId = $link->get('eno');
                    $this->_mUrl = $this->_mBaseUrl[Sd_JumpAction::SD_MODE_CHAR];
                    break;
                case Sd_JumpAction::SD_MODE_PARTY:
                    $this->_mId = $link->get('pno');
                    $this->_mUrl = $this->_mBaseUrl[Sd_JumpAction::SD_MODE_PARTY];
                    break;
                default:
                    $this->_mId = $link->get('eno');
                    break;
            }
        }
        
        return SD_FRAME_VIEW_INDEX;
    }
    
    /**
     * executeViewIndex
     * 
     * @param   XCube_RenderTarget  &$render
     * 
     * @return  void
    **/
    public function executeViewIndex(/*** XCube_RenderTarget ***/ &$render)
    {
        if($this->_mId != null && $this->_mUrl != null)
        {
            $this->mRoot->mController->executeForward(sprintf($this->_mUrl,$this->_mId));
            exit;
        }
        
        $render->setTemplateName($this->mAsset->mDirname . '_jump.html');
        
        $base = XOOPS_URL . '/modules/' . $this->mAsset->mDirname . '/index.php?action=Jump';
        $arr = array();
        if($this->_mId != null)
        {
            foreach($this->_mMode as $mode)
            {
                $arr[constant('_MD_SD_LABEL_JUMP_' . strtoupper($mode))] = sprintf('%s&amp;eno=%d&amp;mode=%s',$base,$this->_mId,$mode);
            }
        }
        
        $render->setAttribute('base_url',$base);
        $render->setAttribute('links',$arr);
    }
}

?>
