<?php
/**
 * @file
 * @package sd
 * @version $Id$
**/

if(!defined('XOOPS_ROOT_PATH'))
{
    exit;
}

/**
 * Sd_AbstractAction
**/
class Sd_AbstractAction
{
    /**
     * @var  XCube_Root
     * 
     * @public
    **/
    var $mRoot = null;

    /**
     * @var  Sd_Module
     * 
     * @public
    **/
    var $mModule = null;

    /**
     * @var  Sd_AssetManager
     * 
     * @public
    **/
    var $mAsset = null;

    /**
     * Sd_AbstractAction
     * 
     * @param   void
     * 
     * @return  void
     * 
     * @public
    **/
    function Sd_AbstractAction()
    {
        $this->mRoot =& XCube_Root::getSingleton();
        $this->mModule =& $this->mRoot->mContext->mModule;
        $this->mAsset =& $this->mModule->mAssetManager;
    }

    /**
     * prepare
     * 
     * @param   void
     * 
     * @return  bool
     * 
     * @public
    **/
    function prepare()
    {
        return true;
    }

    /**
     * hasPermission
     * 
     * @param   void
     * 
     * @return  bool
     * 
     * @public
    **/
    function hasPermission()
    {
        return true;
    }

    /**
     * getDefaultView
     * 
     * @param   void
     * 
     * @return  Enum
     * 
     * @public
    **/
    function getDefaultView()
    {
        return SD_FRAME_VIEW_NONE;
    }

    /**
     * execute
     * 
     * @param   void
     * 
     * @return  Enum
     * 
     * @public
    **/
    function execute()
    {
        return SD_FRAME_VIEW_NONE;
    }

    /**
     * executeViewSuccess
     * 
     * @param   XCube_RenderTarget  &$render
     * 
     * @return  void
     * 
     * @public
    **/
    function executeViewSuccess(&$render)
    {
    }

    /**
     * executeViewError
     * 
     * @param   XCube_RenderTarget  &$render
     * 
     * @return  void
     * 
     * @public
    **/
    function executeViewError(&$render)
    {
    }

    /**
     * executeViewIndex
     * 
     * @param   XCube_RenderTarget  &$render
     * 
     * @return  void
     * 
     * @public
    **/
    function executeViewIndex(&$render)
    {
    }

    /**
     * executeViewInput
     * 
     * @param   XCube_RenderTarget  &$render
     * 
     * @return  void
     * 
     * @public
    **/
    function executeViewInput(&$render)
    {
    }

    /**
     * executeViewPreview
     * 
     * @param   XCube_RenderTarget  &$render
     * 
     * @return  void
     * 
     * @public
    **/
    function executeViewPreview(&$render)
    {
    }

    /**
     * executeViewCancel
     * 
     * @param   XCube_RenderTarget  &$render
     * 
     * @return  void
     * 
     * @public
    **/
    function executeViewCancel(&$render)
    {
    }
}

?>
