<?php
/**
 * @file
 * @package sd
 * @version $Id$
**/

if(!defined('XOOPS_ROOT_PATH'))
{
    exit();
}

define('SD_OBJECT_TYPE_ABILITY','ability');
define('SD_OBJECT_TYPE_ACTIVE_ABILITY','active_ability');
define('SD_OBJECT_TYPE_CHAR','char');
define('SD_OBJECT_TYPE_COSTUME','costume');
define('SD_OBJECT_TYPE_DROP','drop');
define('SD_OBJECT_TYPE_DROP_SEED','drop_seed');
define('SD_OBJECT_TYPE_ELEMENT','element');
define('SD_OBJECT_TYPE_ENEMY','enemy');
define('SD_OBJECT_TYPE_ENEMY_SKILL','enemy_skill');
define('SD_OBJECT_TYPE_ENO_PNO_LINK','eno_pno_link');
define('SD_OBJECT_TYPE_ENUM','enum');
define('SD_OBJECT_TYPE_ICON','icon');
define('SD_OBJECT_TYPE_IMAGE','image');
define('SD_OBJECT_TYPE_ITEM','item');
define('SD_OBJECT_TYPE_ITEM_SLOT','item_slot');
define('SD_OBJECT_TYPE_LEARNED_ABILITY','learned_ability');
define('SD_OBJECT_TYPE_LEARNED_COSTUME','learned_costume');
define('SD_OBJECT_TYPE_LEARNED_SKILL','learned_skill');
define('SD_OBJECT_TYPE_MAP','map');
define('SD_OBJECT_TYPE_MAP_ENEMY_LINK','map_enemy_link');
define('SD_OBJECT_TYPE_MAP_SPOT','map_spot');
define('SD_OBJECT_TYPE_PARTY','party');
define('SD_OBJECT_TYPE_PNO_DROP_LINK','pno_drop_link');
define('SD_OBJECT_TYPE_PNO_ENEMY_LINK','pno_enemy_link');
define('SD_OBJECT_TYPE_PNO_ITEM_LINK','pno_item_link');
define('SD_OBJECT_TYPE_SKILL','skill');
define('SD_OBJECT_TYPE_UPDATE','update');
// define('SD_OBJECT_TYPE_','');


/**
 * @class Sd_Updater
**/
class Sd_Updater
{
    /**
     * @brief   Enum[]
    **/
    protected $_mRefreshTables = array(
        SD_OBJECT_TYPE_ACTIVE_ABILITY,
        SD_OBJECT_TYPE_CHAR,
        SD_OBJECT_TYPE_ELEMENT,
        SD_OBJECT_TYPE_ENO_PNO_LINK,
        SD_OBJECT_TYPE_PNO_DROP_LINK,
        SD_OBJECT_TYPE_PNO_ENEMY_LINK,
        SD_OBJECT_TYPE_PNO_ITEM_LINK
    );
    
    /**
     * @brief   Enum[]
    **/
    protected $_mGCTables = array(
        SD_OBJECT_TYPE_ICON,
        SD_OBJECT_TYPE_IMAGE,
        SD_OBJECT_TYPE_LEARNED_ABILITY,
        SD_OBJECT_TYPE_LEARNED_COSTUME,
        SD_OBJECT_TYPE_LEARNED_SKILL
    );
    
    /**
     * @brief   string
    **/
    protected $_mZipName = null;
    
    /**
     * @brief   Sd_AssetManager
    **/
    protected $_mAssetManagaer = null;
    
    /**
     * __construct
     * 
     * @param   string  $zipName
     * 
     * @return  Sd_Updater
    **/
    public function __construct(/*** string ***/ $zipName)
    {
        $this->_mZipName = $zipName;
        $this->_mAssetManager =& Sd_AssetManager::getInstance(SD_PUBLIC_NAME);
        
        array_walk(glob(SD_TRUST_PATH . '/class/updater/*Updater.class.php'),create_function('$v','require_once $v;'));
    }
    
    /**
     * prepare
     * 
     * @param   void
     * 
     * @return  void
    **/
    public function prepare()
    {
        $root =& XCube_Root::getSingleton();
        $db =& $root->mController->mDB;
        $db->queryF('set names ujis');
        
        foreach($this->_mRefreshTables as $table)
        {
            $db->queryF('truncate `' . $db->prefix('sd_' . $table) . '`');
        }
        
        $db->queryF('delete from `' . $db->prefix('sd_image') . '` where `update_time` = ' . SD_UPDATE_TIME);
        $res = $db->query('select `image_id` from `' . $db->prefix('sd_image') . '` order by `image_id` desc',1);
        $row = $db->fetchArray($res);
        $db->queryF('alter table `' . $db->prefix('sd_image') . '` auto_increment = ' . ((isset($row['image_id']) ? $row['image_id'] : 0) + 1));
        
        $db->queryF('delete from `' . $db->prefix('sd_icon') . '` where `update_time` = ' . SD_UPDATE_TIME);
        $res = $db->query('select `icon_id` from `' . $db->prefix('sd_icon') . '` order by `icon_id` desc',1);
        $db->queryF('alter table `' . $db->prefix('sd_icon') . '` auto_increment = ' . ((isset($row['icon_id']) ? $row['icon_id'] : 0) + 1));
        
        $arr = array();
        if($res = $db->query('select `pno`,`x`,`y` from `' . $db->prefix('sd_party') . '`'))
        {
            while($row = $db->fetchArray($res))
            {
                $arr[$row['pno']] = array('x' => $row['x'],'y' => $row['y']);
            }
        }
        $root->mContext->setAttribute('sd.party.backPoint',$arr);
    }
    
    /**
     * execute
     * 
     * @param   void
     * 
     * @return  void
    **/
    public function execute()
    {
        $zip = new ZipArchive();
        $zip->open($this->_mZipName);
        
        for($i = 0;$i < $zip->numFiles;$i++)
        {
            $arr = array();
            if(preg_match('/([a-zA-Z]+)(\d*)\.html?$/',$zip->getNameIndex($i),$arr))
            {
                $className = 'Sd_' . ucfirst($arr[1]) . 'Updater';
                if(class_exists($className))
                {
                    $obj = new $className();
                    $obj->prepare($this->_mAssetManager,$arr[2]);
                    $obj->execute($zip->getFromIndex($i));
                }
            }
            
            if($i % 100 == 0)
            {
                echo ($i % 1000 == 0 ? '+' : '*');
            }
        }
        
        $zip->close();
    }
    
    /**
     * finish
     * 
     * @param   void
     * 
     * @return  void
    **/
    public function finish()
    {
        $root =& XCube_Root::getSingleton();
        $db =& $root->mController->mDB;
        
        if($res = $db->query('select `m`.`eno` as `eno` from `' . $db->prefix('sd_active_ability') . '` as m left join `' . $db->prefix('sd_char') . '` as c on `m`.`eno` = `c`.`eno` where isnull(`c`.`full_name`) group by `m`.`eno`'))
        {
            $arr = array();
            while($row = $db->fetchArray($res))
            {
                $arr[] = $row['eno'];
            }
            
            if(count($arr) > 0)
            {
                foreach($this->_mGCTables as $table)
                {
                    $db->queryF('delete from `' . $db->prefix('sd_' . $table) . '` where `eno` in (' . implode(',',$arr) . ')');
                    echo 'delete from `',$db->prefix('sd_' . $table),'` where `eno` in (',implode(',',$arr),')',"\n";
                }
            }
        }
        
        $db->queryF('insert ignore into `' . $db->prefix('sd_update') . '` set `update_time` = ' . SD_UPDATE_TIME);
    }
}


/**
 * @interface   Sd_IUpdater
**/
interface Sd_IUpdater
{
    /**
     * prepare
     * 
     * @param   Sd_AssetManager &$asset
     * @param   int             $id
     * 
     * @return  void
    **/
    public function prepare(Sd_AssetManager &$asset,/*** int ***/ $id = null);
    
    /**
     * execute
     * 
     * @param   string  $file
     * 
     * @return  void
    **/
    public function execute(/*** string ***/ $file);
}


/**
 * @class   Sd_AbstractJsUpdater
**/
abstract class Sd_AbstractJsUpdater implements Sd_IUpdater
{
    /**
     * @breif   Sd_AssetManager
    **/
    protected $_mAssetManager = null;
    
    /**
     * @brief   Enum[]
    **/
    protected $_mHandlerList = array();
    
    /**
     * @breif   XoopsGenericHandler
    **/
    protected $_mHandlers = array();
    
    /**
     * @breif   int
    **/
    protected $_mActiveId = null;
    
    /**
     * prepare
     * 
     * @param   Sd_AssetManager &$asset
     * @param   int             $id
     * 
     * @return  void
    **/
    public function prepare(Sd_AssetManager &$asset,/*** int ***/ $id = null)
    {
        $this->_mAssetManager =& $asset;
        $this->_mActiveId = $id;
        
        foreach($this->_mHandlerList as $type)
        {
            $this->_mHandlers[$type] =& $asset->getObject('handler',$type);
        }
    }
    
    /**
     * execute
     * 
     * @param   string  $file
     * 
     * @return  void
    **/
    public function execute(/*** string ***/ $file)
    {
        $arr = array();
        if(preg_match_all('/^([\w]+).+$/m',mb_convert_encoding($file,mb_internal_encoding(),'SJIS'),$arr))
        {
            foreach(array_keys($arr[0]) as $key)
            {
                $func = 'Parse_' . $arr[1][$key];
                if(method_exists($this,$func))
                {
                    $this->$func(trim($arr[0][$key]));
                }
            }
        }
        $this->_save();
    }
    
    /**
     * _save
     * 
     * @param   void
     * 
     * @return  void
    **/
    abstract protected function _save();
    
    /**
     * _convertString
     * 
     * @param   string  $str
     * 
     * @return  void
    **/
    protected function _convertString(/*** string ***/ $str)
    {
        return mb_convert_kana($str,'as',mb_internal_encoding());
    }
    
    /**
     * _parseByRegex
     * 
     * @param   string  $pattern
     * @param   string  $line
     * 
     * @return  string[]
    **/
    protected function _parseByRegex(/*** string ***/ $pattern,/*** string ***/ $line)
    {
        $ret = array();
        if(!preg_match($pattern,$line,$ret))
        {
            $this->_displayError(array('line' => $line,'pattern' => $pattern));
        }
        
        return $ret;
    }
    
    /**
     * _parseByExplode
     * 
     * @param   string  $line
     * @param   int     $count
     * @param   int     $start
     * @param   int     $end
     * @param   string  $spliter
     * 
     * @param   string[]
    **/
    protected function _parseByExplode(/*** string ***/ $line,/*** int ***/ $count,/*** int ***/ $start = 0,/*** int ***/ $end = 0,/*** string ***/ $spliter = ',')
    {
        $ret = explode($spliter,substr($line,$start,$end));
        if(count($ret) != $count)
        {
            $this->_displayError(array('line' => $line,'count' => $count,'start' => $start,'end' => $end,'spliter' => $spliter,'array' => $ret));
        }
        
        return $ret;
    }
    
    /**
     * _insert
     * 
     * @param   Enum                $type
     * @param   XoopsSimpleObject   &$obj
     * 
     * @return  void
    **/
    protected function _insert(/*** Enum ***/ $type,/*** XoopsSimpleObject ***/ &$obj)
    {
        if(!$this->_mHandlers[$type]->insert($obj,true))
        {
            $this->_errorQuery();
        }
    }
    
    /**
     * _delete
     * 
     * @param   Enum                $type
     * @param   XoopsSimpleObject   $obj
     * 
     * @return  void
    **/
    protected function _delete(/*** Enum ***/ $type,/*** XoopsSimpleObject ***/ $obj)
    {
        if(!$this->_mHandlers[$type]->delete($obj,true))
        {
            $this->_errorQuery();
        }
    }
    
    /**
     * _deleteMulti
     * 
     * @param   Enum            $type
     * @param   CriteriaElement $cri
     * 
     * @return  void
    **/
    protected function _deleteMulti(/*** Enum ***/ $type,/*** CriteriaElement ***/ $cri)
    {
        if(!$this->_mHandlers[$type]->deleteMulti($cri,true))
        {
            $this->_errorQuery();
        }
    }
    
    /**
     * _displayError
     * 
     * @param   mixed{} $arr
     * 
     * @return  void
    **/
    protected function _displayError(array $arr)
    {
        $arr['id'] = $this->_mActiveId;
        echo mb_convert_encoding(print_r($arr,true),'SJIS',mb_internal_encoding());
        die('in ' . get_class($this));
    }
    
    /**
     * _errorQuery
     * 
     * @param   void
     * 
     * @return  void
    **/
    protected function _errorQuery()
    {
        $root =& XCube_Root::getSingleton();
        $this->_displayError(array('query' => array_pop($root->mController->mLogger->queries)));
    }
}

?>
