<?php
/**
 * @file
 * @package sd
 * @version $Id$
**/

if(!defined('XOOPS_ROOT_PATH'))
{
    exit;
}

/**
 * Sd_IconObject
**/
class Sd_IconObject extends XoopsSimpleObject
{
    /**
     * Sd_IconObject
     * 
     * @param   void
     * 
     * @return  void
     * 
     * @public
    **/
    function Sd_IconObject()
    {
        $this->initVar('icon_id', XOBJ_DTYPE_INT, '', false);
        $this->initVar('eno', XOBJ_DTYPE_INT, '', false);
        $this->initVar('slot', XOBJ_DTYPE_INT, '', false);
        $this->initVar('icon', XOBJ_DTYPE_STRING, '', false, 255);
        $this->initVar('icon_height', XOBJ_DTYPE_INT, '', false);
        $this->initVar('icon_width', XOBJ_DTYPE_INT, '', false);
        $this->initVar('update_time', XOBJ_DTYPE_INT, '', false);
    }
}

/**
 * Sd_IconHandler
**/
class Sd_IconHandler extends XoopsObjectGenericHandler
{
    /**
     * @var  string
     * 
     * @public
    **/
    var $mTable = '{dirname}_icon';

    /**
     * @var  string
     * 
     * @public
    **/
    var $mPrimary = 'icon_id';

    /**
     * @var  string
     * 
     * @public
    **/
    var $mClass = 'Sd_IconObject';

    /**
     * Sd_IconHandler
     * 
     * @param   XoopsDatabase  &$db
     * @param   string  $dirname
     * 
     * @return  void
     * 
     * @public
    **/
    function Sd_IconHandler(&$db,$dirname)
    {
        $this->mTable = str_replace('{dirname}',$dirname,$this->mTable);
        parent::XoopsObjectGenericHandler($db);
    }
    
    /**
     * getByUnique
     * 
     * @param   int $eno
     * @param   int $slot
     * 
     * @return  Sd_IconObject
    **/
    public function getByUnique(/*** int ***/ $eno,/*** int ***/ $slot)
    {
        $cri = new CriteriaCompo(new Criteria('eno',$eno));
        $cri->add(new CriteriaCompo('slot',$slot));
        $cri->setSort('update_time','desc');
        
        $ret = $this->getObjects($cri,1);
        
        if(is_array($ret) && count($ret) == 1)
        {
            return $ret[0];
        }
        
        return $this->create();
    }
}

?>
