<?php
/**
 * @file
 * @package sd
 * @version $Id$
**/

if(!defined('XOOPS_ROOT_PATH'))
{
    exit;
}

/**
 * Sd_Learned_costumeObject
**/
class Sd_Learned_costumeObject extends XoopsSimpleObject
{
    /**
     * Sd_Learned_costumeObject
     * 
     * @param   void
     * 
     * @return  void
     * 
     * @public
    **/
    function Sd_Learned_costumeObject()
    {
        $this->initVar('eno', XOBJ_DTYPE_INT, '', false);
        $this->initVar('costume_id', XOBJ_DTYPE_INT, '', false);
        $this->initVar('costume_lv', XOBJ_DTYPE_INT, '', false);
        $this->initVar('costume_point', XOBJ_DTYPE_INT, '', false);
    }
}

/**
 * Sd_LearnedCostumeObject
**/
class Sd_LearnedCostumeObject extends XoopsSimpleObject
{
    /**
     * Sd_LearnedCostumeObject
     * 
     * @param   void
     * 
     * @return  void
    **/
    public function Sd_LearnedCostumeObject()
    {
        $this->initVar('eno',XOBJ_DTYPE_INT,'',false);
        $this->initVar('name',XOBJ_DTYPE_STRING,'',false);
    }
}


/**
 * Sd_Learned_costumeHandler
**/
class Sd_Learned_costumeHandler extends XoopsObjectGenericHandler
{
    /**
     * @var  string
     * 
     * @public
    **/
    var $mTable = '{dirname}_learned_costume';

    /**
     * @var  string
     * 
     * @public
    **/
    var $mPrimary = 'eno';

    /**
     * @var  string
     * 
     * @public
    **/
    var $mClass = 'Sd_Learned_costumeObject';

    /**
     * @brief   string
    **/
    protected $_mCharTable = '{dirname}_char';

    /**
     * Sd_Learned_costumeHandler
     * 
     * @param   XoopsDatabase  &$db
     * @param   string  $dirname
     * 
     * @return  void
     * 
     * @public
    **/
    function Sd_Learned_costumeHandler(&$db,$dirname)
    {
        $this->mTable = str_replace('{dirname}',$dirname,$this->mTable);
        parent::XoopsObjectGenericHandler($db);
        
        $this->_mCharTable = $this->db->prefix(str_replace('{dirname}',$dirname,$this->_mCharTable));
    }
    
    /**
     * getByUnique
     * 
     * @param   int $eno
     * @param   int $costumeId
     * 
     * @return  Sd_Learned_costumeObject
    **/
    public function getByUnique(/*** int ***/ $eno,/*** int ***/ $costumeId)
    {
        $cri = new CriteriaCompo(new Criteria('eno',$eno));
        $cri->add(new Criteria('costume_id',$costumeId));
        
        
        $ret = $this->getObjects($cri);
        
        if(is_array($ret) && count($ret) == 1)
        {
            return $ret[0];
        }
        
        return $this->create();
    }
    
    /**
     * &getLearningChars
     * 
     * @param   CriteriaElement $cri
     * 
     * @return  Sd_LearnedCostumeObject[]
    **/
    public function &getLearningChars(CriteriaElement $cri)
    {
        $ret = array();
        $sql = 'select `c`.`eno` as eno,`c`.`full_name` as name from `' . $this->_mCharTable . '` as c ';
        $where = '';
        
        for($i = 0;$i < $cri->getCountChildElements();$i++)
        {
            $c = $cri->getChildElement($i);
            $sql .= XCube_Utils::formatString('left join `{0}` as w{1} on `c`.`eno` = `w{1}`.`eno` ',$this->mTable,$i);
            $where .= XCube_Utils::formatString('{0}`w{1}`.`costume_id` = {2} ',($i > 0 ? 'and ' : ''),$i,intval($c->getValue()));
        }
        
        $sql .= 'where ' . $where . 'order by `c`.`eno` asc';
        
        if($res = $this->db->query($sql,$cri->getLimit(),$cri->getStart()))
        {
            while($row = $this->db->fetchArray($res))
            {
                $obj = new Sd_LearnedCostumeObject();
                $obj->setVars($row);
                $ret[] =& $obj;
                unset($obj);
            }
        }
        
        return $ret;
    }
    
    /**
     * getLearningCharsCount
     * 
     * @param   CriteriaElement $cri
     * 
     * @return  int
    **/
    public function getLearningCharsCount(CriteriaElement $cri)
    {
        $c = $cri->getChildElement(0);
        $sql = 'select count(*) as c from `' . $this->mTable . '` as w0 ';
        $where = '`w0`.`costume_id` = ' . intval($c->getValue()) . ' ';
        
        for($i = 1;$i < $cri->getCountChildElements();$i++)
        {
            $c = $cri->getChildElement($i);
            $sql .= XCube_Utils::formatString('left join `{0}` as w{1} on `w0`.`eno` = `w{1}`.`eno` ',$this->mTable,$i);
            $where .= XCube_Utils::formatString('and `w{0}`.`costume_id` = {1} ',$i,intval($c->getValue()));
        }
        
        $sql .= 'where ' . $where;
        
        if($res = $this->db->query($sql))
        {
            $row = $this->db->fetchArray($res);
            
            return $row['c'];
        }
        
        return null;
    }
    
    /**
     * _update
     * 
     * @param   Sd_Learned_costumeObject    &$obj
     * 
     * @return  string
     * 
     * @access  protected
    **/
    public function _update(Sd_Learned_costumeObject &$obj)
    {
        return sprintf(
            'update `%s` set `costume_lv` = %d,`costume_point` = %d where `eno` = %d and `costume_id` = %d',
            $this->mTable,$obj->get('costume_lv'),$obj->get('costume_point'),$obj->get('eno'),$obj->get('costume_id')
        );
    }
}

?>
