<?php
/**
 * @file
 * @package sd
 * @version $Id$
**/

if(!defined('XOOPS_ROOT_PATH'))
{
    exit;
}

/**
 * Sd_Map_enemy_linkObject
**/
class Sd_Map_enemy_linkObject extends XoopsSimpleObject
{
    /**
     * Sd_Map_enemy_linkObject
     * 
     * @param   void
     * 
     * @return  void
     * 
     * @public
    **/
    function Sd_Map_enemy_linkObject()
    {
        $this->initVar('x', XOBJ_DTYPE_INT, '', false);
        $this->initVar('y', XOBJ_DTYPE_INT, '', false);
        $this->initVar('enemy_id', XOBJ_DTYPE_INT, '', false);
    }
}

/**
 * Sd_Map_enemy_linkHandler
**/
class Sd_Map_enemy_linkHandler extends XoopsObjectGenericHandler
{
    /**
     * @var  string
     * 
     * @public
    **/
    var $mTable = '{dirname}_map_enemy_link';

    /**
     * @var  string
     * 
     * @public
    **/
    var $mPrimary = 'x';

    /**
     * @var  string
     * 
     * @public
    **/
    var $mClass = 'Sd_Map_enemy_linkObject';

    /**
     * Sd_Map_enemy_linkHandler
     * 
     * @param   XoopsDatabase  &$db
     * @param   string  $dirname
     * 
     * @return  void
     * 
     * @public
    **/
    function Sd_Map_enemy_linkHandler(&$db,$dirname)
    {
        $this->mTable = str_replace('{dirname}',$dirname,$this->mTable);
        parent::XoopsObjectGenericHandler($db);
    }
    
    /**
     * get
     * 
     * @param   int $x
     * @param   int $y
     * @param   int $enemyId
     * 
     * @return  Sd_Map_enemy_link
    **/
    public function get(/*** int ***/ $x,/*** int ***/ $y,/*** int ***/ $enemyId)
    {
        $cri = new CriteriaCompo(new Criteria('x',$x));
        $cri->add(new Criteria('y',$y));
        $cri->add(new Criteria('enemy_id',$enemyId));
        $ret = $this->getObjects($cri);
        
        if(is_array($ret) && count($ret) == 1)
        {
            return $ret[0];
        }
        
        return null;
    }
}

?>
