<?php
/**
 * @file
 * @package sd
 * @version $Id$
**/

if(!defined('XOOPS_ROOT_PATH'))
{
    exit;
}

/**
 * Sd_UpdateObject
**/
class Sd_UpdateObject extends XoopsSimpleObject
{
    /**
     * Sd_UpdateObject
     * 
     * @param   void
     * 
     * @return  void
     * 
     * @public
    **/
    function Sd_UpdateObject()
    {
        $this->initVar('update_time', XOBJ_DTYPE_INT, '', false);
    }
    
    /**
     * getFormatDate
     * 
     * @param   string  $format
     *              'Y' YYYY
     *              'y' yy
     *              'm' mm
     *              'd' dd
     * 
     * @param   string
    **/
    public function getFormatDate(/*** string ***/ $format = 'Y/m/d')
    {
        $updateTime = $this->get('update_time') + 20000000;
        $pat = array('Y','y','m','d');
        $rep = array(
            intval($updateTime / 10000),
            substr($updateTime,2,2),
            substr($updateTime,4,2),
            substr($updateTime,6,2)
        );
        
        return str_replace($pat,$rep,$format);
    }
}

/**
 * Sd_UpdateHandler
**/
class Sd_UpdateHandler extends XoopsObjectGenericHandler
{
    /**
     * @var  string
     * 
     * @public
    **/
    var $mTable = '{dirname}_update';

    /**
     * @var  string
     * 
     * @public
    **/
    var $mPrimary = 'update_time';

    /**
     * @var  string
     * 
     * @public
    **/
    var $mClass = 'Sd_UpdateObject';

    /**
     * Sd_UpdateHandler
     * 
     * @param   XoopsDatabase  &$db
     * @param   string  $dirname
     * 
     * @return  void
     * 
     * @public
    **/
    function Sd_UpdateHandler(&$db,$dirname)
    {
        $this->mTable = str_replace('{dirname}',$dirname,$this->mTable);
        parent::XoopsObjectGenericHandler($db);
    }
    
    /**
     * getUpdateTimeList
     * 
     * @param   void
     * 
     * @return  Sd_UpdateObject[]
    **/
    public function getUpdateTimeList()
    {
        $cri = new Criteria(1,1);
        $cri->setSort('update_time','desc');
        
        return $this->getObjects($cri);
    }
}

?>
