<?php
/**
 * @file
 * @package sd
 * @version $Id$
**/

if(!defined('XOOPS_ROOT_PATH'))
{
    exit;
}

require_once SD_TRUST_PATH . '/class/AbstractFilterForm.class.php';

define('SD_ABILITY_SORT_KEY_ABILITY_ID', 1);
define('SD_ABILITY_SORT_KEY_ABILITY_NAME', 2);
define('SD_ABILITY_SORT_KEY_DESCRIPTION', 3);
define('SD_ABILITY_SORT_KEY_ABILITY_COST', 4);
define('SD_ABILITY_SORT_KEY_COSTUME_ID', 5);
define('SD_ABILITY_SORT_KEY_COSTUME_LV', 6);
define('SD_ABILITY_SORT_KEY_DEFAULT', SD_ABILITY_SORT_KEY_ABILITY_ID);

/**
 * Sd_AbilityFilterForm
**/
class Sd_AbilityFilterForm extends Sd_AbstractFilterForm
{
    /**
     * @var  string[]
     * 
     * @public
    **/
    var $mSortKeys = array(
        SD_ABILITY_SORT_KEY_ABILITY_ID => 'ability_id',
        SD_ABILITY_SORT_KEY_ABILITY_NAME => 'ability_name',
        SD_ABILITY_SORT_KEY_DESCRIPTION => 'description',
        SD_ABILITY_SORT_KEY_ABILITY_COST => 'ability_cost',
        SD_ABILITY_SORT_KEY_COSTUME_ID => 'costume_id',
        SD_ABILITY_SORT_KEY_COSTUME_LV => 'costume_lv'
    );

    /**
     * getDefaultSortKey
     * 
     * @param   void
     * 
     * @return  void
     * 
     * @public
    **/
    function getDefaultSortKey()
    {
        return SD_ABILITY_SORT_KEY_DEFAULT;
    }

    /**
     * fetch
     * 
     * @param   void
     * 
     * @return  void
     * 
     * @public
    **/
    function fetch()
    {
        parent::fetch();
    
        $root =& XCube_Root::getSingleton();
    
        if (($value = $root->mContext->mRequest->getRequest('ability_id')) !== null) {
            $this->mNavi->addExtra('ability_id', $value);
            $this->_mCriteria->add(new Criteria('ability_id', $value));
        }
    
        if (($value = $root->mContext->mRequest->getRequest('ability_name')) !== null) {
            $this->mNavi->addExtra('ability_name', $value);
            $this->_mCriteria->add(new Criteria('ability_name', $value));
        }
    
        if (($value = $root->mContext->mRequest->getRequest('description')) !== null) {
            $this->mNavi->addExtra('description', $value);
            $this->_mCriteria->add(new Criteria('description', $value));
        }
    
        if (($value = $root->mContext->mRequest->getRequest('ability_cost')) !== null) {
            $this->mNavi->addExtra('ability_cost', $value);
            $this->_mCriteria->add(new Criteria('ability_cost', $value));
        }
    
        if (($value = $root->mContext->mRequest->getRequest('costume_id')) !== null) {
            $this->mNavi->addExtra('costume_id', $value);
            $this->_mCriteria->add(new Criteria('costume_id', $value));
        }
    
        if (($value = $root->mContext->mRequest->getRequest('costume_lv')) !== null) {
            $this->mNavi->addExtra('costume_lv', $value);
            $this->_mCriteria->add(new Criteria('costume_lv', $value));
        }
    
        if (($value = $root->mContext->mRequest->getRequest('regist_time')) != null) {
            $this->_mCriteria->add(new Criteria('regist_time', $value));
        }
        $this->mNavi->addExtra('regist_time', $value);
    
        $this->_mCriteria->addSort($this->getSort(), $this->getOrder());
    }
}

?>
