<?php
/**
 * @file
 * @package sd
 * @version $Id$
**/

if(!defined('XOOPS_ROOT_PATH'))
{
    exit;
}

require_once SD_TRUST_PATH . '/class/AbstractFilterForm.class.php';

define('SD_COSTUME_SORT_KEY_COSTUME_ID', 1);
define('SD_COSTUME_SORT_KEY_COSTUME_NAME', 2);
define('SD_COSTUME_SORT_KEY_GROW_LIFE', 3);
define('SD_COSTUME_SORT_KEY_GROW_SOUL', 4);
define('SD_COSTUME_SORT_KEY_GROW_POW', 5);
define('SD_COSTUME_SORT_KEY_GROW_STR', 6);
define('SD_COSTUME_SORT_KEY_GROW_DEX', 7);
define('SD_COSTUME_SORT_KEY_GROW_SPEED', 8);
define('SD_COSTUME_SORT_KEY_GROW_MAG', 9);
define('SD_COSTUME_SORT_KEY_GROW_REG', 10);
define('SD_COSTUME_SORT_KEY_GROW_CON', 11);
define('SD_COSTUME_SORT_KEY_MODIFY_HP', 12);
define('SD_COSTUME_SORT_KEY_MODIFY_TP', 13);
define('SD_COSTUME_SORT_KEY_MODIFY_AT', 14);
define('SD_COSTUME_SORT_KEY_MODIFY_DF', 15);
define('SD_COSTUME_SORT_KEY_MODIFY_MAT', 16);
define('SD_COSTUME_SORT_KEY_MODIFY_MDF', 17);
define('SD_COSTUME_SORT_KEY_MODIFY_ACT', 18);
define('SD_COSTUME_SORT_KEY_MOVE_COST', 19);
define('SD_COSTUME_SORT_KEY_DEFAULT', SD_COSTUME_SORT_KEY_COSTUME_ID);

/**
 * Sd_CostumeFilterForm
**/
class Sd_CostumeFilterForm extends Sd_AbstractFilterForm
{
    /**
     * @var  string[]
     * 
     * @public
    **/
    var $mSortKeys = array(
        SD_COSTUME_SORT_KEY_COSTUME_ID => 'costume_id',
        SD_COSTUME_SORT_KEY_COSTUME_NAME => 'costume_name',
        SD_COSTUME_SORT_KEY_GROW_LIFE => 'grow_life',
        SD_COSTUME_SORT_KEY_GROW_SOUL => 'grow_soul',
        SD_COSTUME_SORT_KEY_GROW_POW => 'grow_pow',
        SD_COSTUME_SORT_KEY_GROW_STR => 'grow_str',
        SD_COSTUME_SORT_KEY_GROW_DEX => 'grow_dex',
        SD_COSTUME_SORT_KEY_GROW_SPEED => 'grow_speed',
        SD_COSTUME_SORT_KEY_GROW_MAG => 'grow_mag',
        SD_COSTUME_SORT_KEY_GROW_REG => 'grow_reg',
        SD_COSTUME_SORT_KEY_GROW_CON => 'grow_con',
        SD_COSTUME_SORT_KEY_MODIFY_HP => 'modify_hp',
        SD_COSTUME_SORT_KEY_MODIFY_TP => 'modify_tp',
        SD_COSTUME_SORT_KEY_MODIFY_AT => 'modify_at',
        SD_COSTUME_SORT_KEY_MODIFY_DF => 'modify_df',
        SD_COSTUME_SORT_KEY_MODIFY_MAT => 'modify_mat',
        SD_COSTUME_SORT_KEY_MODIFY_MDF => 'modify_mdf',
        SD_COSTUME_SORT_KEY_MODIFY_ACT => 'modify_act',
        SD_COSTUME_SORT_KEY_MOVE_COST => 'move_cost'
    );

    /**
     * getDefaultSortKey
     * 
     * @param   void
     * 
     * @return  void
     * 
     * @public
    **/
    function getDefaultSortKey()
    {
        return SD_COSTUME_SORT_KEY_DEFAULT;
    }

    /**
     * fetch
     * 
     * @param   void
     * 
     * @return  void
     * 
     * @public
    **/
    function fetch()
    {
        parent::fetch();
    
        $root =& XCube_Root::getSingleton();
    
        if (($value = $root->mContext->mRequest->getRequest('costume_id')) !== null) {
            $this->mNavi->addExtra('costume_id', $value);
            $this->_mCriteria->add(new Criteria('costume_id', $value));
        }
    
        if (($value = $root->mContext->mRequest->getRequest('costume_name')) !== null) {
            $this->mNavi->addExtra('costume_name', $value);
            $this->_mCriteria->add(new Criteria('costume_name', $value));
        }
    
        if (($value = $root->mContext->mRequest->getRequest('grow_life')) !== null) {
            $this->mNavi->addExtra('grow_life', $value);
            $this->_mCriteria->add(new Criteria('grow_life', $value));
        }
    
        if (($value = $root->mContext->mRequest->getRequest('grow_soul')) !== null) {
            $this->mNavi->addExtra('grow_soul', $value);
            $this->_mCriteria->add(new Criteria('grow_soul', $value));
        }
    
        if (($value = $root->mContext->mRequest->getRequest('grow_pow')) !== null) {
            $this->mNavi->addExtra('grow_pow', $value);
            $this->_mCriteria->add(new Criteria('grow_pow', $value));
        }
    
        if (($value = $root->mContext->mRequest->getRequest('grow_str')) !== null) {
            $this->mNavi->addExtra('grow_str', $value);
            $this->_mCriteria->add(new Criteria('grow_str', $value));
        }
    
        if (($value = $root->mContext->mRequest->getRequest('grow_dex')) !== null) {
            $this->mNavi->addExtra('grow_dex', $value);
            $this->_mCriteria->add(new Criteria('grow_dex', $value));
        }
    
        if (($value = $root->mContext->mRequest->getRequest('grow_speed')) !== null) {
            $this->mNavi->addExtra('grow_speed', $value);
            $this->_mCriteria->add(new Criteria('grow_speed', $value));
        }
    
        if (($value = $root->mContext->mRequest->getRequest('grow_mag')) !== null) {
            $this->mNavi->addExtra('grow_mag', $value);
            $this->_mCriteria->add(new Criteria('grow_mag', $value));
        }
    
        if (($value = $root->mContext->mRequest->getRequest('grow_reg')) !== null) {
            $this->mNavi->addExtra('grow_reg', $value);
            $this->_mCriteria->add(new Criteria('grow_reg', $value));
        }
    
        if (($value = $root->mContext->mRequest->getRequest('grow_con')) !== null) {
            $this->mNavi->addExtra('grow_con', $value);
            $this->_mCriteria->add(new Criteria('grow_con', $value));
        }
    
        if (($value = $root->mContext->mRequest->getRequest('modify_hp')) !== null) {
            $this->mNavi->addExtra('modify_hp', $value);
            $this->_mCriteria->add(new Criteria('modify_hp', $value));
        }
    
        if (($value = $root->mContext->mRequest->getRequest('modify_tp')) !== null) {
            $this->mNavi->addExtra('modify_tp', $value);
            $this->_mCriteria->add(new Criteria('modify_tp', $value));
        }
    
        if (($value = $root->mContext->mRequest->getRequest('modify_at')) !== null) {
            $this->mNavi->addExtra('modify_at', $value);
            $this->_mCriteria->add(new Criteria('modify_at', $value));
        }
    
        if (($value = $root->mContext->mRequest->getRequest('modify_df')) !== null) {
            $this->mNavi->addExtra('modify_df', $value);
            $this->_mCriteria->add(new Criteria('modify_df', $value));
        }
    
        if (($value = $root->mContext->mRequest->getRequest('modify_mat')) !== null) {
            $this->mNavi->addExtra('modify_mat', $value);
            $this->_mCriteria->add(new Criteria('modify_mat', $value));
        }
    
        if (($value = $root->mContext->mRequest->getRequest('modify_mdf')) !== null) {
            $this->mNavi->addExtra('modify_mdf', $value);
            $this->_mCriteria->add(new Criteria('modify_mdf', $value));
        }
    
        if (($value = $root->mContext->mRequest->getRequest('modify_act')) !== null) {
            $this->mNavi->addExtra('modify_act', $value);
            $this->_mCriteria->add(new Criteria('modify_act', $value));
        }
    
        if (($value = $root->mContext->mRequest->getRequest('move_cost')) !== null) {
            $this->mNavi->addExtra('move_cost', $value);
            $this->_mCriteria->add(new Criteria('move_cost', $value));
        }
    
        if (($value = $root->mContext->mRequest->getRequest('regist_time')) != null) {
            $this->_mCriteria->add(new Criteria('regist_time', $value));
        }
        $this->mNavi->addExtra('regist_time', $value);
    
        $this->_mCriteria->addSort($this->getSort(), $this->getOrder());
    }
}

?>
