<?php
/**
 * @file
 * @package sd
 * @version $Id$
**/

if(!defined('XOOPS_ROOT_PATH'))
{
    exit;
}

require_once SD_TRUST_PATH . '/class/AbstractFilterForm.class.php';

define('SD_DROP_SORT_KEY_DROP_ID', 1);
define('SD_DROP_SORT_KEY_DROP_NAME', 2);
define('SD_DROP_SORT_KEY_SEED', 3);
define('SD_DROP_SORT_KEY_LV', 4);
define('SD_DROP_SORT_KEY_ELEMENT', 5);
define('SD_DROP_SORT_KEY_GIFT', 6);
define('SD_DROP_SORT_KEY_REGIST_TIME', 7);
define('SD_DROP_SORT_KEY_DEFAULT', SD_DROP_SORT_KEY_DROP_ID);

/**
 * Sd_DropFilterForm
**/
class Sd_DropFilterForm extends Sd_AbstractFilterForm
{
    /**
     * @var  string[]
     * 
     * @public
    **/
    var $mSortKeys = array(
        SD_DROP_SORT_KEY_DROP_ID => 'drop_id',
        SD_DROP_SORT_KEY_DROP_NAME => 'drop_name',
        SD_DROP_SORT_KEY_SEED => 'seed',
        SD_DROP_SORT_KEY_LV => 'lv',
        SD_DROP_SORT_KEY_ELEMENT => 'element',
        SD_DROP_SORT_KEY_GIFT => 'gift',
        SD_DROP_SORT_KEY_REGIST_TIME => 'regist_time'
    );

    /**
     * getDefaultSortKey
     * 
     * @param   void
     * 
     * @return  void
     * 
     * @public
    **/
    function getDefaultSortKey()
    {
        return SD_DROP_SORT_KEY_DEFAULT;
    }

    /**
     * fetch
     * 
     * @param   void
     * 
     * @return  void
     * 
     * @public
    **/
    function fetch()
    {
        parent::fetch();
    
        $root =& XCube_Root::getSingleton();
    
        if (($value = $root->mContext->mRequest->getRequest('drop_name')) !== null) {
            $this->mNavi->addExtra('drop_name', $value);
            $this->_mCriteria->add(new Criteria('drop_name', $value));
        }
    
        if (($value = $root->mContext->mRequest->getRequest('seed')) !== null) {
            $this->mNavi->addExtra('seed', $value);
            $this->_mCriteria->add(new Criteria('seed', $value));
        }
    
        if (($value = $root->mContext->mRequest->getRequest('lv')) !== null) {
            $this->mNavi->addExtra('lv', $value);
            $this->_mCriteria->add(new Criteria('lv', $value));
        }
    
        if (($value = $root->mContext->mRequest->getRequest('element')) !== null) {
            $this->mNavi->addExtra('element', $value);
            $this->_mCriteria->add(new Criteria('element', $value));
        }
    
        if (($value = $root->mContext->mRequest->getRequest('gift')) !== null) {
            $this->mNavi->addExtra('gift', $value);
            $this->_mCriteria->add(new Criteria('gift', $value));
        }
    
        if (($value = $root->mContext->mRequest->getRequest('regist_time')) != null) {
            $this->_mCriteria->add(new Criteria('regist_time', $value));
        }
        $this->mNavi->addExtra('regist_time', $value);
    
        $this->_mCriteria->add(new Criteria('lv',0,'>'));
    
        $this->_mCriteria->addSort('drop_name', 'asc');
        $this->_mCriteria->addSort('lv','asc');
    }
}

?>
