<?php
/**
 * @file
 * @package sd
 * @version $Id$
**/

if(!defined('XOOPS_ROOT_PATH'))
{
    exit;
}

require_once SD_TRUST_PATH . '/class/AbstractFilterForm.class.php';

define('SD_LEARNED_COSTUME_SORT_KEY_ENO', 1);
define('SD_LEARNED_COSTUME_SORT_KEY_COSTUME_ID', 2);
define('SD_LEARNED_COSTUME_SORT_KEY_COSTUME_LV', 3);
define('SD_LEARNED_COSTUME_SORT_KEY_COSTUME_POINT', 4);
define('SD_LEARNED_COSTUME_SORT_KEY_DEFAULT', SD_LEARNED_COSTUME_SORT_KEY_ENO);

/**
 * Sd_Learned_costumeFilterForm
**/
class Sd_Learned_costumeFilterForm extends Sd_AbstractFilterForm
{
    /**
     * @var  string[]
     * 
     * @public
    **/
    var $mSortKeys = array(
        SD_LEARNED_COSTUME_SORT_KEY_ENO => 'eno',
        SD_LEARNED_COSTUME_SORT_KEY_COSTUME_ID => 'costume_id',
        SD_LEARNED_COSTUME_SORT_KEY_COSTUME_LV => 'costume_lv',
        SD_LEARNED_COSTUME_SORT_KEY_COSTUME_POINT => 'costume_point'
    );

    /**
     * getDefaultSortKey
     * 
     * @param   void
     * 
     * @return  void
     * 
     * @public
    **/
    function getDefaultSortKey()
    {
        return SD_LEARNED_COSTUME_SORT_KEY_DEFAULT;
    }

    /**
     * getTotalItems
     * 
     * @param   int  &$total
     * 
     * @return  void
     * 
     * @protected
    **/
    function getTotalItems(&$total)
    {
        $total = $this->_mHandler->getLearningCharsCount($this->getCriteria());
    }

    /**
     * fetch
     * 
     * @param   void
     * 
     * @return  void
     * 
     * @public
    **/
    function fetch()
    {
        parent::fetch();
    
        $root =& XCube_Root::getSingleton();
    
        if (($value = $root->mContext->mRequest->getRequest('eno')) !== null) {
            $this->mNavi->addExtra('eno', $value);
            $this->_mCriteria->add(new Criteria('eno', $value));
        }
    
        if (($value = $root->mContext->mRequest->getRequest('costume_id')) !== null) {
            $ext =  array();
            foreach((is_array($value) ? $value : explode(',',$value)) as $v)
            {
                if($v != null)
                {
                    $ext[] = $v;
                    $this->_mCriteria->add(new Criteria('costume_id', $v));
                }
            }
            $this->mNavi->addExtra('costume_id', implode(',',$ext));
        }
    
        if (($value = $root->mContext->mRequest->getRequest('costume_lv')) !== null) {
            $this->mNavi->addExtra('costume_lv', $value);
            $this->_mCriteria->add(new Criteria('costume_lv', $value));
        }
    
        if (($value = $root->mContext->mRequest->getRequest('costume_point')) !== null) {
            $this->mNavi->addExtra('costume_point', $value);
            $this->_mCriteria->add(new Criteria('costume_point', $value));
        }
    
        if(!$this->_mCriteria->hasChildElements())
        {
            $this->_mCriteria->add(new Criteria('costume_id',-1));
        }
    
        $this->_mCriteria->addSort($this->getSort(), $this->getOrder());
    }
}

?>
