<?php
/**
 * @file
 * @package sd
 * @version $Id$
**/

if(!defined('XOOPS_ROOT_PATH'))
{
    exit;
}

require_once SD_TRUST_PATH . '/class/AbstractFilterForm.class.php';

define('SD_MAP_SORT_KEY_X', 1);
define('SD_MAP_SORT_KEY_Y', 2);
define('SD_MAP_SORT_KEY_SPOT_ID', 3);
define('SD_MAP_SORT_KEY_UPDATE_TIME', 4);
define('SD_MAP_SORT_KEY_DEFAULT', SD_MAP_SORT_KEY_X);

/**
 * Sd_MapFilterForm
**/
class Sd_MapFilterForm extends Sd_AbstractFilterForm
{
    /**
     * @var  string[]
     * 
     * @public
    **/
    var $mSortKeys = array(
        SD_MAP_SORT_KEY_X => 'x',
        SD_MAP_SORT_KEY_Y => 'y',
        SD_MAP_SORT_KEY_SPOT_ID => 'spot_id',
        SD_MAP_SORT_KEY_UPDATE_TIME => 'update_time'
    );

    /**
     * getDefaultSortKey
     * 
     * @param   void
     * 
     * @return  void
     * 
     * @public
    **/
    function getDefaultSortKey()
    {
        return SD_MAP_SORT_KEY_DEFAULT;
    }

    /**
     * fetch
     * 
     * @param   void
     * 
     * @return  void
     * 
     * @public
    **/
    function fetch()
    {
        parent::fetch();
    
        $root =& XCube_Root::getSingleton();
    
        if (($value = $root->mContext->mRequest->getRequest('x')) !== null) {
            $this->mNavi->addExtra('x', $value);
            $this->_mCriteria->add(new Criteria('x', $value));
        }
    
        if (($value = $root->mContext->mRequest->getRequest('y')) !== null) {
            $this->mNavi->addExtra('y', $value);
            $this->_mCriteria->add(new Criteria('y', $value));
        }
    
        if (($value = $root->mContext->mRequest->getRequest('spot_id')) !== null) {
            $this->mNavi->addExtra('spot_id', $value);
            $this->_mCriteria->add(new Criteria('spot_id', $value));
        }
    
        if (($value = $root->mContext->mRequest->getRequest('update_time')) !== null) {
            $this->mNavi->addExtra('update_time', $value);
            $this->_mCriteria->add(new Criteria('update_time', $value));
        }
    
        $this->_mCriteria->addSort($this->getSort(), $this->getOrder());
    }
}

?>
