<?php
/**
 * @file
 * @package sd
 * @version $Id$
**/

if(!defined('XOOPS_ROOT_PATH'))
{
    exit;
}

require_once SD_TRUST_PATH . '/class/AbstractFilterForm.class.php';

define('SD_SKILL_SORT_KEY_SKILL_ID', 1);
define('SD_SKILL_SORT_KEY_SKILL_NAME', 2);
define('SD_SKILL_SORT_KEY_DESCRIPTION', 3);
define('SD_SKILL_SORT_KEY_RANGE', 4);
define('SD_SKILL_SORT_KEY_TARGET', 5);
define('SD_SKILL_SORT_KEY_ELEMENT', 6);
define('SD_SKILL_SORT_KEY_KIND', 7);
define('SD_SKILL_SORT_KEY_TP', 8);
define('SD_SKILL_SORT_KEY_DEFAULT', SD_SKILL_SORT_KEY_SKILL_ID);

/**
 * Sd_SkillFilterForm
**/
class Sd_SkillFilterForm extends Sd_AbstractFilterForm
{
    /**
     * @var  string[]
     * 
     * @public
    **/
    var $mSortKeys = array(
        SD_SKILL_SORT_KEY_SKILL_ID => 'skill_id',
        SD_SKILL_SORT_KEY_SKILL_NAME => 'skill_name',
        SD_SKILL_SORT_KEY_DESCRIPTION => 'description',
        SD_SKILL_SORT_KEY_RANGE => 'range',
        SD_SKILL_SORT_KEY_TARGET => 'target',
        SD_SKILL_SORT_KEY_ELEMENT => 'element',
        SD_SKILL_SORT_KEY_KIND => 'kind',
        SD_SKILL_SORT_KEY_TP => 'tp'
    );

    /**
     * getDefaultSortKey
     * 
     * @param   void
     * 
     * @return  void
     * 
     * @public
    **/
    function getDefaultSortKey()
    {
        return SD_SKILL_SORT_KEY_DEFAULT;
    }

    /**
     * fetch
     * 
     * @param   void
     * 
     * @return  void
     * 
     * @public
    **/
    function fetch()
    {
        parent::fetch();
    
        $root =& XCube_Root::getSingleton();
    
        if (($value = $root->mContext->mRequest->getRequest('skill_id')) !== null) {
            $this->mNavi->addExtra('skill_id', $value);
            $this->_mCriteria->add(new Criteria('skill_id', $value));
        }
    
        if (($value = $root->mContext->mRequest->getRequest('skill_name')) !== null) {
            $this->mNavi->addExtra('skill_name', $value);
            $this->_mCriteria->add(new Criteria('skill_name', $value));
        }
    
        if (($value = $root->mContext->mRequest->getRequest('description')) !== null) {
            $this->mNavi->addExtra('description', $value);
            $this->_mCriteria->add(new Criteria('description', $value));
        }
    
        if (($value = $root->mContext->mRequest->getRequest('range')) !== null) {
            $this->mNavi->addExtra('range', $value);
            $this->_mCriteria->add(new Criteria('range', $value));
        }
    
        if (($value = $root->mContext->mRequest->getRequest('target')) !== null) {
            $this->mNavi->addExtra('target', $value);
            $this->_mCriteria->add(new Criteria('target', $value));
        }
    
        if (($value = $root->mContext->mRequest->getRequest('element')) !== null) {
            $this->mNavi->addExtra('element', $value);
            $this->_mCriteria->add(new Criteria('element', $value));
        }
    
        if (($value = $root->mContext->mRequest->getRequest('kind')) !== null) {
            $this->mNavi->addExtra('kind', $value);
            $this->_mCriteria->add(new Criteria('kind', $value));
        }
    
        if (($value = $root->mContext->mRequest->getRequest('tp')) !== null) {
            $this->mNavi->addExtra('tp', $value);
            $this->_mCriteria->add(new Criteria('tp', $value));
        }
    
        if (($value = $root->mContext->mRequest->getRequest('regist_time')) != null) {
            $this->_mCriteria->add(new Criteria('regist_time', $value));
        }
        $this->mNavi->addExtra('regist_time', $value);
    
        $this->_mCriteria->addSort($this->getSort(), $this->getOrder());
    }
}

?>
