CREATE TABLE `{prefix}_{dirname}_ability` (
  `ability_id` int(10) unsigned NOT NULL,
  `ability_name` varchar(50) NOT NULL,
  `description` varchar(255) NOT NULL,
  `ability_cost` tinyint(3) unsigned NOT NULL,
  `costume_id` int(10) unsigned NOT NULL,
  `costume_lv` tinyint(3) unsigned NOT NULL,
  `regist_time` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`ability_id`),
  UNIQUE KEY `ability_name` (`ability_name`),
  KEY `regist_time` (`regist_time`,`ability_id`)
) ENGINE=MyISAM;

CREATE TABLE `{prefix}_{dirname}_active_ability` (
  `eno` int(10) unsigned NOT NULL,
  `slot` tinyint(3) unsigned NOT NULL,
  `ability_id` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`ability_id`,`eno`),
  UNIQUE KEY `eno` (`eno`,`slot`)
) ENGINE=MyISAM;

CREATE TABLE `{prefix}_{dirname}_char` (
  `eno` int(10) unsigned NOT NULL,
  `full_name` varchar(40) NOT NULL,
  `nick_name` varchar(16) NOT NULL,
  `battle_name` varchar(16) NOT NULL,
  `sex` tinyint(3) unsigned NOT NULL,
  `age` int(10) unsigned NOT NULL,
  `height` int(10) unsigned NOT NULL,
  `weight` int(10) unsigned NOT NULL,
  `kind` tinyint(3) unsigned NOT NULL,
  `element_base` tinyint(3) unsigned NOT NULL,
  `element_ext` tinyint(3) unsigned NOT NULL,
  `active_costume` int(10) unsigned NOT NULL,
  `status_lv` tinyint(3) unsigned NOT NULL,
  `status_life` int(10) unsigned NOT NULL,
  `status_soul` int(10) unsigned NOT NULL,
  `status_pow` int(10) unsigned NOT NULL,
  `status_str` int(10) unsigned NOT NULL,
  `status_dex` int(10) unsigned NOT NULL,
  `status_speed` int(10) unsigned NOT NULL,
  `status_mag` int(10) unsigned NOT NULL,
  `status_reg` int(10) unsigned NOT NULL,
  `status_con` int(10) unsigned NOT NULL,
  `status_exp` int(10) unsigned NOT NULL,
  `status_money` int(10) unsigned NOT NULL,
  `status_sp` int(10) unsigned NOT NULL,
  `hp_base` int(10) unsigned NOT NULL,
  `at_base` int(10) unsigned NOT NULL,
  `df_base` int(10) unsigned NOT NULL,
  `mat_base` int(10) unsigned NOT NULL,
  `mdf_base` int(10) unsigned NOT NULL,
  `act_base` int(10) unsigned NOT NULL,
  `move_base` int(10) unsigned NOT NULL,
  `hp_modify` int(10) NOT NULL,
  `at_modify` int(10) NOT NULL,
  `df_modify` int(10) NOT NULL,
  `mat_modify` int(10) NOT NULL,
  `mdf_modify` int(10) NOT NULL,
  `act_modify` int(10) NOT NULL,
  `move_modify` int(10) NOT NULL,
  `hp_equip` int(10) NOT NULL,
  `at_equip` int(10) NOT NULL,
  `df_equip` int(10) NOT NULL,
  `mat_equip` int(10) NOT NULL,
  `mdf_equip` int(10) NOT NULL,
  `act_equip` int(10) NOT NULL,
  `move_equip` int(10) NOT NULL,
  PRIMARY KEY  (`eno`)
) ENGINE=MyISAM;

CREATE TABLE `{prefix}_{dirname}_costume` (
  `costume_id` int(10) unsigned NOT NULL,
  `costume_name` varchar(50) NOT NULL,
  `grow_life` tinyint(3) unsigned NOT NULL,
  `grow_soul` tinyint(3) unsigned NOT NULL,
  `grow_pow` tinyint(3) unsigned NOT NULL,
  `grow_str` tinyint(3) unsigned NOT NULL,
  `grow_dex` tinyint(3) unsigned NOT NULL,
  `grow_speed` tinyint(3) unsigned NOT NULL,
  `grow_mag` tinyint(3) unsigned NOT NULL,
  `grow_reg` tinyint(3) unsigned NOT NULL,
  `grow_con` tinyint(3) unsigned NOT NULL,
  `modify_hp` tinyint(3) NOT NULL,
  `modify_tp` tinyint(3) NOT NULL,
  `modify_at` tinyint(3) NOT NULL,
  `modify_df` tinyint(3) NOT NULL,
  `modify_mat` tinyint(3) NOT NULL,
  `modify_mdf` tinyint(3) NOT NULL,
  `modify_act` tinyint(3) NOT NULL,
  `move_cost` tinyint(3) unsigned NOT NULL,
  `regist_time` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`costume_id`),
  KEY `regist_time` (`regist_time`,`costume_id`)
) ENGINE=MyISAM;

CREATE TABLE `{prefix}_{dirname}_drop` (
  `drop_id` int(10) unsigned NOT NULL auto_increment,
  `drop_name` varchar(50) default NULL,
  `seed` tinyint(3) unsigned NOT NULL,
  `lv` tinyint(3) unsigned NOT NULL,
  `element` tinyint(4) NOT NULL,
  `gift` varchar(50) NOT NULL,
  `regist_time` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`drop_id`),
  UNIQUE KEY `drop_name` (`drop_name`,`lv`,`gift`),
  KEY `regist_time` (`regist_time`,`drop_name`,`lv`)
) ENGINE=MyISAM;

CREATE TABLE `{prefix}_{dirname}_drop_seed` (
  `drop_seed_id` tinyint(3) unsigned NOT NULL auto_increment,
  `drop_seed_name` varchar(50) NOT NULL,
  PRIMARY KEY  (`drop_seed_id`),
  UNIQUE KEY `drop_seed_name` (`drop_seed_name`)
) ENGINE=MyISAM;

CREATE TABLE `{prefix}_{dirname}_element` (
  `eno` int(10) unsigned NOT NULL,
  `ele_at_aqua` tinyint(3) NOT NULL,
  `ele_at_flame` tinyint(3) NOT NULL,
  `ele_at_wood` tinyint(3) NOT NULL,
  `ele_at_wind` tinyint(3) NOT NULL,
  `ele_at_iron` tinyint(3) NOT NULL,
  `ele_at_life` tinyint(3) NOT NULL,
  `ele_at_earth` tinyint(3) NOT NULL,
  `ele_at_thunder` tinyint(3) NOT NULL,
  `ele_at_light` tinyint(3) NOT NULL,
  `ele_at_star` tinyint(3) NOT NULL,
  `ele_at_dark` tinyint(3) NOT NULL,
  `ele_at_flower` tinyint(3) NOT NULL,
  `ele_df_aqua` tinyint(3) NOT NULL,
  `ele_df_flame` tinyint(3) NOT NULL,
  `ele_df_wood` tinyint(3) NOT NULL,
  `ele_df_wind` tinyint(3) NOT NULL,
  `ele_df_iron` tinyint(3) NOT NULL,
  `ele_df_life` tinyint(3) NOT NULL,
  `ele_df_earth` tinyint(3) NOT NULL,
  `ele_df_thunder` tinyint(3) NOT NULL,
  `ele_df_light` tinyint(3) NOT NULL,
  `ele_df_star` tinyint(3) NOT NULL,
  `ele_df_dark` tinyint(3) NOT NULL,
  `ele_df_flower` tinyint(3) NOT NULL,
  PRIMARY KEY  (`eno`)
) ENGINE=MyISAM;

CREATE TABLE `{prefix}_{dirname}_enemy` (
  `enemy_id` int(10) unsigned NOT NULL auto_increment,
  `enemy_name` varchar(50) NOT NULL,
  `attack_kind` tinyint(3) unsigned NOT NULL,
  `position` tinyint(3) unsigned NOT NULL,
  `regist_time` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`enemy_id`),
  UNIQUE KEY `enemy_name` (`enemy_name`),
  KEY `regist_time` (`regist_time`)
) ENGINE=MyISAM;

CREATE TABLE `{prefix}_{dirname}_enemy_skill` (
  `link_id` int(10) unsigned NOT NULL auto_increment,
  `enemy_id` int(10) unsigned NOT NULL,
  `skill_name` varchar(50) NOT NULL,
  PRIMARY KEY  (`link_id`),
  UNIQUE KEY `enemy_id` (`enemy_id`,`skill_name`)
) ENGINE=MyISAM;

CREATE TABLE `{prefix}_{dirname}_eno_pno_link` (
  `eno` int(10) unsigned NOT NULL,
  `pno` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`eno`)
) ENGINE=MyISAM;

CREATE TABLE `{prefix}_{dirname}_icon` (
  `icon_id` int(10) unsigned NOT NULL auto_increment,
  `eno` int(10) unsigned NOT NULL,
  `slot` tinyint(3) unsigned NOT NULL,
  `icon` varchar(255) NOT NULL,
  `icon_height` tinyint(3) unsigned NOT NULL,
  `icon_width` tinyint(3) unsigned NOT NULL,
  `update_time` int(11) NOT NULL,
  PRIMARY KEY  (`icon_id`),
  UNIQUE KEY `eno` (`eno`,`slot`,`update_time`),
  KEY `update_time` (`update_time`,`eno`)
) ENGINE=MyISAM;

CREATE TABLE `{prefix}_{dirname}_image` (
  `image_id` int(10) unsigned NOT NULL auto_increment,
  `eno` int(10) unsigned NOT NULL,
  `image` varchar(255) NOT NULL,
  `image_height` int(10) unsigned NOT NULL,
  `image_width` int(10) unsigned NOT NULL,
  `image_link` varchar(255) NOT NULL,
  `update_time` int(10) NOT NULL,
  PRIMARY KEY  (`image_id`),
  UNIQUE KEY `eno` (`eno`,`update_time`),
  KEY `update_time` (`update_time`)
) ENGINE=MyISAM;

CREATE TABLE `{prefix}_{dirname}_item` (
  `item_id` int(10) unsigned NOT NULL auto_increment,
  `item_name` varchar(50) NOT NULL,
  `kind` tinyint(3) unsigned NOT NULL,
  `lv` tinyint(3) unsigned NOT NULL,
  `element` tinyint(4) NOT NULL,
  `at` int(11) NOT NULL,
  `df` int(11) NOT NULL,
  `mat` int(11) NOT NULL,
  `mdf` int(11) NOT NULL,
  `range` int(11) NOT NULL,
  `regist_time` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`item_id`)
) ENGINE=MyISAM;

CREATE TABLE `{prefix}_{dirname}_item_slot` (
  `item_id` int(10) unsigned NOT NULL,
  `slot` tinyint(3) unsigned NOT NULL,
  `drop_id` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`item_id`,`slot`),
  KEY `drop_id` (`drop_id`)
) ENGINE=MyISAM;

CREATE TABLE `{prefix}_{dirname}_learned_ability` (
  `eno` int(10) unsigned NOT NULL,
  `ability_id` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`eno`,`ability_id`),
  KEY `ability_id` (`ability_id`)
) ENGINE=MyISAM;

CREATE TABLE `{prefix}_{dirname}_learned_costume` (
  `eno` int(10) unsigned NOT NULL,
  `costume_id` int(10) unsigned NOT NULL,
  `costume_lv` tinyint(3) unsigned NOT NULL,
  `costume_point` tinyint(3) unsigned NOT NULL,
  PRIMARY KEY  (`eno`,`costume_id`),
  KEY `costume_id` (`costume_id`)
) ENGINE=MyISAM;

CREATE TABLE `{prefix}_{dirname}_learned_skill` (
  `eno` int(10) unsigned NOT NULL,
  `skill_id` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`eno`,`skill_id`),
  KEY `skill_id` (`skill_id`)
) ENGINE=MyISAM;

CREATE TABLE `{prefix}_{dirname}_map` (
  `x` tinyint(4) NOT NULL,
  `y` tinyint(4) NOT NULL,
  `spot_id` tinyint(3) unsigned NOT NULL,
  `update_time` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`x`,`y`),
  KEY `y` (`y`),
  KEY `spot_id` (`spot_id`)
) ENGINE=MyISAM;

CREATE TABLE `{prefix}_{dirname}_map_enemy_link` (
  `x` tinyint(4) NOT NULL,
  `y` tinyint(4) NOT NULL,
  `enemy_id` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`x`,`y`,`enemy_id`),
  KEY `enemy_id` (`enemy_id`)
) ENGINE=MyISAM;

CREATE TABLE `{prefix}_{dirname}_map_spot` (
  `spot_id` tinyint(3) unsigned NOT NULL auto_increment,
  `spot_name` varchar(50) NOT NULL,
  `description` text NOT NULL,
  `update_time` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`spot_id`),
  UNIQUE KEY `spot_name` (`spot_name`)
) ENGINE=MyISAM;

CREATE TABLE `{prefix}_{dirname}_party` (
  `pno` int(10) unsigned NOT NULL,
  `party_name` varchar(50) NOT NULL,
  `x` tinyint(4) NOT NULL,
  `y` tinyint(4) NOT NULL,
  `turn` tinyint(3) unsigned NOT NULL,
  `result` tinyint(3) unsigned NOT NULL,
  `get_exp` int(10) unsigned NOT NULL,
  `get_money` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`pno`),
  KEY `x` (`x`,`y`)
) ENGINE=MyISAM;

CREATE TABLE `{prefix}_{dirname}_pno_drop_link` (
  `pno` int(10) unsigned NOT NULL,
  `drop_id` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`pno`,`drop_id`)
) ENGINE=MyISAM;

CREATE TABLE `{prefix}_{dirname}_pno_enemy_link` (
  `pno` int(10) unsigned NOT NULL,
  `enemy_id` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`pno`,`enemy_id`),
  KEY `enemy_id` (`enemy_id`,`pno`)
) ENGINE=MyISAM;

CREATE TABLE `{prefix}_{dirname}_pno_item_link` (
  `pno` int(10) unsigned NOT NULL,
  `item_id` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`pno`,`item_id`),
  KEY `item_id` (`item_id`,`pno`)
) ENGINE=MyISAM;

CREATE TABLE `{prefix}_{dirname}_skill` (
  `skill_id` int(10) unsigned NOT NULL,
  `skill_name` varchar(50) NOT NULL,
  `description` varchar(255) NOT NULL,
  `range` tinyint(3) unsigned NOT NULL,
  `target` tinyint(3) unsigned NOT NULL,
  `element` varchar(3) NOT NULL,
  `kind` tinyint(3) unsigned NOT NULL,
  `tp` int(10) unsigned NOT NULL,
  `regist_time` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`skill_id`),
  UNIQUE KEY `skill_name` (`skill_name`),
  KEY `regist_time` (`regist_time`,`skill_id`)
) ENGINE=MyISAM;

CREATE TABLE `{prefix}_{dirname}_update` (
  `update_time` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`update_time`)
) ENGINE=MyISAM;
